package com.hiramine.alertdialogclosecontrolsample;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

public class AlertDialogCloseControlSampleActivity extends Activity
		implements OnClickListener
{
	private static final int	WC						= LinearLayout.LayoutParams.WRAP_CONTENT;
	private static final int	FP						= LinearLayout.LayoutParams.FILL_PARENT;

	private static final int	BUTTONTAG_SHOWDIALOG	= 0;

	private AlertDialog			m_dlg;
	private EditText			m_edittext;

	/** Called when the activity is first created. */
	@Override
	public void onCreate( Bundle savedInstanceState )
	{
		super.onCreate( savedInstanceState );

		LinearLayout layout = new LinearLayout( this );
		layout.setOrientation( LinearLayout.VERTICAL );
		setContentView( layout );

		Button button = new Button( this );
		button.setText( "Show Input Dialog" );
		button.setTag( BUTTONTAG_SHOWDIALOG );
		button.setOnClickListener( this );
		button.setLayoutParams( new LinearLayout.LayoutParams( FP, WC ) );
		layout.addView( button );
	}

	public void onClick( View v )
	{
		int iTag = (Integer)v.getTag();
		if( BUTTONTAG_SHOWDIALOG == iTag )
		{
			AlertDialog.Builder adb = new AlertDialog.Builder( this );
			adb.setTitle( "Input Dialog" );
			m_edittext = new EditText( this );
			adb.setView( m_edittext );
			adb.setPositiveButton( "OK", null );
			m_dlg = adb.show();

			// Builder#setPositiveButton() でリスナーを指定した場合、ダイアログは閉じてしまう。
			// Button#setOnClickListener() でリスナーを指定する。
			Button buttonOK = m_dlg.getButton( DialogInterface.BUTTON_POSITIVE );
			buttonOK.setOnClickListener( new View.OnClickListener()
			{
				public void onClick( View v )
				{
					if( m_edittext.getText().toString().equals( "" ) )
					{ // エディットボックスが空の場合は、ダイアログを閉じない。
						Toast.makeText( AlertDialogCloseControlSampleActivity.this, "Please enter some text.", Toast.LENGTH_SHORT ).show();
					}
					else
					{ // エディットボックスが空でなければ、ダイアログを閉じる。
						m_dlg.dismiss();
						m_dlg = null;
						Toast.makeText( AlertDialogCloseControlSampleActivity.this, m_edittext.getText().toString(), Toast.LENGTH_SHORT ).show();
					}
				}
			} );
		}
	}
}
